#include <math.h>
#include <string.h>
#include <time.h>
#include <float.h>
#include <limits.h>
#include <ctype.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#include <Fl/Fl_Window.H>
#include <Fl/Fl_Box.H>
#include <Fl/Fl_Button.H>
#include <FL/fl_draw.H>
#include <Fl/fl_ask.H>
#include <Fl/Fl_Menu_Bar.H>
#include <Fl/Fl_Tabs.H>
#include <Fl/Fl_Output.H>
#include <Fl/Fl_Printer.H>
#include <Fl/Fl_File_Chooser.H>
#include <Fl/names.h>

#define MAXLINELENGTH 10000

#include "images/up.xpm"
#include "images/down.xpm"
#include "images/left.xpm"
#include "images/right.xpm"
#include "images/csvview.xpm"

#include "conf.h"
#include "canvas.hpp"
#include "mainwin.hpp"

myWindow *main_win;

#include "ui.cxx"
UserInterface *ui;
char WorkFileName[PATH_MAX];
int g_argc;
char **g_argv;

#include "parseline.c"
#include "conf.c"
#include "tmp_handling.c"
#include "fct.cpp"
#include "canvas.cpp"
#include "mainwin.cpp"

int main(int argc, char** argv)
{
	int r;
	readConfigFile(getConfName(),0);
	loadtextfile(languageFile);
#ifndef WIN32
	Fl_Pixmap p_icon(csvview_xpm);
	Fl_RGB_Image img_icon(&p_icon,0);
#endif
	FL_NORMAL_SIZE=10;
	ui=new UserInterface();
	//ui->win->show();
	main_win=new myWindow(800,600,"Hauptfenster");
	main_win->size_range(400,300);
	readConfigFile(getConfName(),main_win->view);
#ifndef WIN32
	main_win->default_icon(&img_icon);
#endif
	main_win->show();
	//if(argc>1) FileOpen(main_win->view,argv[1]);
	g_argc=argc;
	g_argv=argv;
	evalCmdArgs();
	if(strlen(WorkFileName)) FileOpen(main_win->view,WorkFileName);
	r=Fl::run();
	writeConfig(getConfName(),main_win->view);
	purgetext();
	return r;
}
